# Code of Conduct

## 1. Purpose

A primary goal of the Mina Protocol project is to be inclusive to the largest number of contributors, with the most varied and diverse backgrounds possible. As such, all contributors and maintainers of the project are expected to foster a friendly, safe, and welcoming environment for all, regardless of age, body size, disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, religion, or sexual identity and orientation.

This Code of Conduct outlines the community's expectations for all participants.

## 2. Open [Source/Culture/Tech] Citizenship

A supplemental goal of this Code of Conduct is to increase open [source/culture/tech] citizenship by encouraging participants to recognize and strengthen the relationships between our actions and their effects on our community.

Communities mirror the societies in which they exist and positive action is essential to counteract the many forms of inequality and abuses of power that exist in society.

If you see someone who is making an extra effort to ensure our community is welcoming, friendly, and encourages all participants to contribute to the fullest extent, we want to know.

## 3. Standards

While this is not an exhaustive list, below are examples of both positive and negative behavior.

Examples of positive behavior include:

- Participating in an authentic and active way. In doing so, you contribute to the health and longevity of this community.
- Exercising consideration and respect in your speech and actions.
- Attempting collaboration before conflict.
- Refraining from demeaning, discriminatory, or harassing behavior and speech.
- Being mindful of your surroundings and of your fellow participants. Alert community leaders if you notice a dangerous situation, someone in distress, or violations of this Code of Conduct, even if they seem inconsequential.
- Being mindful that community event venues may be shared with members of the public; please be respectful to all patrons of these locations.

Examples of unacceptable behavior include:

- Violence, threats of violence or violent language directed against another person.
- Sexist, racist, homophobic, transphobic, ableist or otherwise discriminatory jokes and language.
- Posting or displaying sexually explicit or violent material.
- Posting or threatening to post other people's personally identifying information ("doxing").
- Personal insults, particularly those related to gender, sexual orientation, race, religion, or disability.
- Inappropriate photography or recording.
- Unwelcome sexual attention. This includes, sexualized comments or jokes; inappropriate physical contact, groping, and unwelcomed sexual advances.
- Deliberate intimidation, trolling, stalking or following (online or in person).
- Advocating for, or encouraging, any of the above behavior.
- Sustained disruption of community events, including talks and presentations.

## 4. Weapons Policy

No weapons will be allowed at Mina community events, spaces, or in other spaces covered by the scope of this Code of Conduct. Weapons include but are not limited to guns, explosives (including fireworks), and large knives such as those used for hunting or display, as well as any other item used for the purpose of causing injury or harm to others. Anyone seen in possession of one of these items will be asked to leave immediately, and will only be allowed to return without the weapon. Community members are further expected to comply with all state and local laws on this matter.

## 5. Consequences of Unacceptable Behavior

Unacceptable behavior from any community member, including sponsors and those with decision-making authority, will not be tolerated.

Anyone asked to stop unacceptable behavior is expected to comply immediately.

If a community member engages in unacceptable behavior, the community organizers may take any action they deem appropriate, up to and including a temporary ban or permanent expulsion from the community.

## 6. Reporting Guidelines

If you are subject to or witness unacceptable behavior, or have any other concerns, please notify the Mina community as soon as possible by emailing contact@minaprotocol.org. You can also contact an admin in the [Discord server](https://bit.ly/MinaDiscord).

Additionally, community organizers are available to help community members engage with local law enforcement or to otherwise help those experiencing unacceptable behavior feel safe. In the context of in-person events, organizers will also provide escorts as desired by the person experiencing distress.

If you feel you have been falsely or unfairly accused of violating this Code of Conduct, please send an email to contact@minaprotocol.org with a concise description of your grievance. The project maintainers will review your email and take any appropriate actions.

## 7. Scope

We expect all community participants (contributors, paid or otherwise; sponsors; and other guests) to abide by this Code of Conduct in all community venues--online and in-person--as well as in all one-on-one communications pertaining to community business.

This Code of Conduct and its related procedures also applies to unacceptable behavior occurring outside the scope of community activities when such behavior has the potential to adversely affect the safety and well-being of community members.

## 8. License and attribution

This Code of Conduct is adapted from the [Stumptown Syndicate](https://github.com/stumpsyn) Code of Conduct under a [Creative Commons Attribution-ShareAlike license](http://creativecommons.org/licenses/by-sa/3.0/).

Portions of text derived from the [Django Code of Conduct](https://www.djangoproject.com/conduct/) and the [Geek Feminism Anti-Harassment Policy](http://geekfeminism.wikia.com/wiki/Conference_anti-harassment/Policy).
